﻿using System;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;

[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class ServerOPC : Service
{
    #region GetStatus
    [System.Web.Services.WebMethodAttribute()]
    [System.Web.Services.Protocols.SoapDocumentMethodAttribute("http://opcfoundation.org/webservices/XMLDA/1.0/GetStatus", RequestNamespace = "http://opcfoundation.org/webservices/XMLDA/1.0/", ResponseNamespace = "http://opcfoundation.org/webservices/XMLDA/1.0/", Use = System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle = System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
    public override ReplyBase GetStatus([System.Xml.Serialization.XmlAttributeAttribute()] string LocaleID, [System.Xml.Serialization.XmlAttributeAttribute()] string ClientRequestHandle, out ServerStatus Status)
    {
        ReplyBase Response = new ReplyBase();
        Response.RcvTime = System.DateTime.Now;
        Response.ServerState = serverState.running;
        Response.ClientRequestHandle = "Client Handle modificato dal server";
        Response.RevisedLocaleID = "IT";

        Status = new ServerStatus();
        Status.ProductVersion = "Product version";
        Status.StartTime = new DateTime(2008, 06, 04, 11, 0, 0);
        Status.StatusInfo = "Status info";
        Status.SupportedInterfaceVersions = new interfaceVersion[1];
        Status.SupportedInterfaceVersions[0] = interfaceVersion.XML_DA_Version_1_0;
        Status.SupportedLocaleIDs = new string[1];
        Status.SupportedLocaleIDs[0] = "IT";
        Status.VendorInfo = "Vendor INFO";

        Response.ReplyTime = System.DateTime.Now;
        return Response;
    }
    #endregion

    #region Read
    [System.Web.Services.WebMethodAttribute()]
    [System.Web.Services.Protocols.SoapDocumentMethodAttribute("http://opcfoundation.org/webservices/XMLDA/1.0/Read", RequestNamespace = "http://opcfoundation.org/webservices/XMLDA/1.0/", ResponseNamespace = "http://opcfoundation.org/webservices/XMLDA/1.0/", Use = System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle = System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
    public override ReplyBase Read(RequestOptions Options, ReadRequestItemList ItemList, out ReplyItemList RItemList, [System.Xml.Serialization.XmlElementAttribute("Errors")] out OPCError[] Errors)
    {
        ReplyBase Response = new ReplyBase();
        Response.RcvTime = System.DateTime.Now;
        Response.ServerState = serverState.running;
        Response.ClientRequestHandle = Options.ClientRequestHandle;
        Response.RevisedLocaleID = "IT";

        RItemList = new ReplyItemList();
        RItemList.Reserved = "Stringa riservata";
        RItemList.Items = new ItemValue[2];
        RItemList.Items[0] = new ItemValue();
        RItemList.Items[0].ClientItemHandle = "Client Handle for Item 0";
        RItemList.Items[0].DiagnosticInfo = "Diagnostic Info for Item 0";
        RItemList.Items[0].ItemName = "Name for Item 0";
        RItemList.Items[0].ItemPath = "Path for Item 0";
        RItemList.Items[0].Quality = new OPCQuality();
        RItemList.Items[0].ResultID = new System.Xml.XmlQualifiedName();
        RItemList.Items[0].Timestamp = new DateTime(2008, 06, 04, 12, 30, 00);
        RItemList.Items[0].TimestampSpecified = true;
        RItemList.Items[0].Value = "Valore della variabile numero zero";
        RItemList.Items[0].ValueTypeQualifier = new System.Xml.XmlQualifiedName();

        RItemList.Items[1] = new ItemValue();
        RItemList.Items[1].ClientItemHandle = "Client Handle for Item 1";
        RItemList.Items[1].DiagnosticInfo = "Diagnostic Info for Item 1";
        RItemList.Items[1].ItemName = "Name for Item 1";
        RItemList.Items[1].ItemPath = "Path for Item 1";
        RItemList.Items[1].Quality = new OPCQuality();
        RItemList.Items[1].ResultID = new System.Xml.XmlQualifiedName();
        RItemList.Items[1].Timestamp = new DateTime(2008, 06, 04, 12, 30, 00);
        RItemList.Items[1].TimestampSpecified = true;
        RItemList.Items[1].Value = "Valore della variabile numero uno";
        RItemList.Items[1].ValueTypeQualifier = new System.Xml.XmlQualifiedName();

        Errors = new OPCError[2];
        Errors[0] = new OPCError();
        Errors[0].ID = new System.Xml.XmlQualifiedName();
        Errors[0].Text = "Testo dell'errore 0";
        Errors[1] = new OPCError();
        Errors[1].ID = new System.Xml.XmlQualifiedName();
        Errors[1].Text = "Testo dell'errore 1";
        Response.ReplyTime = System.DateTime.Now;
        return Response;
    }
    #endregion

    #region Write
    [System.Web.Services.WebMethodAttribute()]
    [System.Web.Services.Protocols.SoapDocumentMethodAttribute("http://opcfoundation.org/webservices/XMLDA/1.0/Write", RequestNamespace = "http://opcfoundation.org/webservices/XMLDA/1.0/", ResponseNamespace = "http://opcfoundation.org/webservices/XMLDA/1.0/", Use = System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle = System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
    public override ReplyBase Write(RequestOptions Options, WriteRequestItemList ItemList, [System.Xml.Serialization.XmlAttributeAttribute()] bool ReturnValuesOnReply, out ReplyItemList RItemList, [System.Xml.Serialization.XmlElementAttribute("Errors")] out OPCError[] Errors)
    {
        RItemList = null;
        Errors = null;
        ReplyBase Response = new ReplyBase();
        return Response;
    }
    #endregion
    
    #region Subscribe
    [System.Web.Services.WebMethodAttribute()]
    [System.Web.Services.Protocols.SoapDocumentMethodAttribute("http://opcfoundation.org/webservices/XMLDA/1.0/Subscribe", RequestNamespace = "http://opcfoundation.org/webservices/XMLDA/1.0/", ResponseNamespace = "http://opcfoundation.org/webservices/XMLDA/1.0/", Use = System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle = System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
    public override ReplyBase Subscribe(RequestOptions Options, SubscribeRequestItemList ItemList, [System.Xml.Serialization.XmlAttributeAttribute()] bool ReturnValuesOnReply, [System.Xml.Serialization.XmlAttributeAttribute()] [System.ComponentModel.DefaultValueAttribute(0)] int SubscriptionPingRate, out SubscribeReplyItemList RItemList, [System.Xml.Serialization.XmlElementAttribute("Errors")] out OPCError[] Errors, [System.Xml.Serialization.XmlAttributeAttribute()] out string ServerSubHandle)
    {
        RItemList = null;
        Errors = null;
        ServerSubHandle = null;
        ReplyBase Response = new ReplyBase();
        return Response;
    }
    #endregion

    #region  SubscriptionPolledRefresh
    [System.Web.Services.WebMethodAttribute()]
    [System.Web.Services.Protocols.SoapDocumentMethodAttribute("http://opcfoundation.org/webservices/XMLDA/1.0/SubscriptionPolledRefresh", RequestNamespace = "http://opcfoundation.org/webservices/XMLDA/1.0/", ResponseNamespace = "http://opcfoundation.org/webservices/XMLDA/1.0/", Use = System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle = System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
    public override ReplyBase SubscriptionPolledRefresh(RequestOptions Options, [System.Xml.Serialization.XmlElementAttribute("ServerSubHandles")] string[] ServerSubHandles, [System.Xml.Serialization.XmlAttributeAttribute()] System.DateTime HoldTime, [System.Xml.Serialization.XmlAttributeAttribute()] [System.Xml.Serialization.XmlIgnoreAttribute()] bool HoldTimeSpecified, [System.Xml.Serialization.XmlAttributeAttribute()] [System.ComponentModel.DefaultValueAttribute(0)] int WaitTime, [System.Xml.Serialization.XmlAttributeAttribute()] [System.ComponentModel.DefaultValueAttribute(false)] bool ReturnAllItems, [System.Xml.Serialization.XmlElementAttribute("InvalidServerSubHandles")] out string[] InvalidServerSubHandles, [System.Xml.Serialization.XmlElementAttribute("RItemList")] out SubscribePolledRefreshReplyItemList[] RItemList, [System.Xml.Serialization.XmlElementAttribute("Errors")] out OPCError[] Errors, [System.Xml.Serialization.XmlAttributeAttribute()] [System.ComponentModel.DefaultValueAttribute(false)] out bool DataBufferOverflow)
    {
        InvalidServerSubHandles = null;
        RItemList = null;
        Errors = null;
        DataBufferOverflow = false;
        ReplyBase Response = new ReplyBase();
        return Response;
    }
    #endregion

    #region SubscriptionCancel
    [System.Web.Services.WebMethodAttribute()]
    [System.Web.Services.Protocols.SoapDocumentMethodAttribute("http://opcfoundation.org/webservices/XMLDA/1.0/SubscriptionCancel", RequestNamespace = "http://opcfoundation.org/webservices/XMLDA/1.0/", ResponseNamespace = "http://opcfoundation.org/webservices/XMLDA/1.0/", Use = System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle = System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
    public override void SubscriptionCancel([System.Xml.Serialization.XmlAttributeAttribute()] string ServerSubHandle, [System.Xml.Serialization.XmlAttributeAttribute()] ref string ClientRequestHandle)
    {
    }
    #endregion

    #region Browse
    [System.Web.Services.WebMethodAttribute()]
    [System.Web.Services.Protocols.SoapDocumentMethodAttribute("http://opcfoundation.org/webservices/XMLDA/1.0/Browse", RequestNamespace = "http://opcfoundation.org/webservices/XMLDA/1.0/", ResponseNamespace = "http://opcfoundation.org/webservices/XMLDA/1.0/", Use = System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle = System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
    public override ReplyBase Browse(
                [System.Xml.Serialization.XmlElementAttribute("PropertyNames")] System.Xml.XmlQualifiedName[] PropertyNames,
                [System.Xml.Serialization.XmlAttributeAttribute()] string LocaleID,
                [System.Xml.Serialization.XmlAttributeAttribute()] string ClientRequestHandle,
                [System.Xml.Serialization.XmlAttributeAttribute()] string ItemPath,
                [System.Xml.Serialization.XmlAttributeAttribute()] string ItemName,
                [System.Xml.Serialization.XmlAttributeAttribute()] ref string ContinuationPoint,
                [System.Xml.Serialization.XmlAttributeAttribute()] [System.ComponentModel.DefaultValueAttribute(0)] int MaxElementsReturned,
                [System.Xml.Serialization.XmlAttributeAttribute()] [System.ComponentModel.DefaultValueAttribute(browseFilter.all)] browseFilter BrowseFilter,
                [System.Xml.Serialization.XmlAttributeAttribute()] string ElementNameFilter,
                [System.Xml.Serialization.XmlAttributeAttribute()] string VendorFilter,
                [System.Xml.Serialization.XmlAttributeAttribute()] [System.ComponentModel.DefaultValueAttribute(false)] bool ReturnAllProperties,
                [System.Xml.Serialization.XmlAttributeAttribute()] [System.ComponentModel.DefaultValueAttribute(false)] bool ReturnPropertyValues,
                [System.Xml.Serialization.XmlAttributeAttribute()] [System.ComponentModel.DefaultValueAttribute(false)] bool ReturnErrorText,
                [System.Xml.Serialization.XmlElementAttribute("Elements")] out BrowseElement[] Elements,
                [System.Xml.Serialization.XmlElementAttribute("Errors")] out OPCError[] Errors,
                [System.Xml.Serialization.XmlAttributeAttribute()] [System.ComponentModel.DefaultValueAttribute(false)] out bool MoreElements)
    {
        Elements = null;
        Errors = null;
        MoreElements = false;
        ReplyBase Response = new ReplyBase();
        return Response;
    }
    #endregion

    #region GetProperties
    [System.Web.Services.WebMethodAttribute()]
    [System.Web.Services.Protocols.SoapDocumentMethodAttribute("http://opcfoundation.org/webservices/XMLDA/1.0/GetProperties", RequestNamespace = "http://opcfoundation.org/webservices/XMLDA/1.0/", ResponseNamespace = "http://opcfoundation.org/webservices/XMLDA/1.0/", Use = System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle = System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
    public override ReplyBase GetProperties([System.Xml.Serialization.XmlElementAttribute("ItemIDs")] ItemIdentifier[] ItemIDs, [System.Xml.Serialization.XmlElementAttribute("PropertyNames")] System.Xml.XmlQualifiedName[] PropertyNames, [System.Xml.Serialization.XmlAttributeAttribute()] string LocaleID, [System.Xml.Serialization.XmlAttributeAttribute()] string ClientRequestHandle, [System.Xml.Serialization.XmlAttributeAttribute()] string ItemPath, [System.Xml.Serialization.XmlAttributeAttribute()] [System.ComponentModel.DefaultValueAttribute(false)] bool ReturnAllProperties, [System.Xml.Serialization.XmlAttributeAttribute()] [System.ComponentModel.DefaultValueAttribute(false)] bool ReturnPropertyValues, [System.Xml.Serialization.XmlAttributeAttribute()] [System.ComponentModel.DefaultValueAttribute(false)] bool ReturnErrorText, [System.Xml.Serialization.XmlElementAttribute("PropertyLists")] out PropertyReplyList[] PropertyLists, [System.Xml.Serialization.XmlElementAttribute("Errors")] out OPCError[] Errors)
    {
        PropertyLists = null;
        Errors = null;
        ReplyBase Response = new ReplyBase();
        return Response;
    }
    #endregion
}